#include <stdio.h>

/*
 * C ist eine prozedurale Programmiersprache, hierbei werden
 * Instruktionen nacheinander ausgeführt. ("procedere" == voranschreiten)
 * D.h. zuerst die erste Instruktion, dann die zweite usw.
 */

int main(){

  // C ist eine typisierte Sprache, d.h. Variablen sind von einem Datentyp
  // Jeder Datentyp bestimmt welche Operationen möglich sind.

  // In C unterscheidet man zwischen Deklaration und Definition von Variablen.
  // Eine Deklaration legt den Variablennamen und den Datentypen fest.

  // Hier deklarieren wir die Variable zahlEins als vom Typ "Integer" == Ganzahl.
  // Der Variable wird auch Speicherplatz zugewiesen, daher wird die Variable auch
  // definiert.
  // Der Wert also der Inhalt des Speicherplatzes, d.h. welche Zahl in dem konkreten Fall ist noch unbekannt.
  // Der Compiler kann den Speicherplatz auch mit einem Wert, z.B.  -3584958 initalisieren.
  int zahlEins;

  // wir geben den Wert der Variable aus. "%d" gibt das Format bei der Ausgabe, an (in dem Fall: Integer)
  printf("Der wert der zahlEins ist %d\n", zahlEins);

  // Wir weisen der Variablen die Zahl 5 zu.
  zahlEins = 5;

  printf("Der wert der zahlEins ist nach der Zuweisung %d\n", zahlEins);

  printf("Vorsicht eine Zuweisung a = b und ein Vergleich wird mit zwei = geschrieben, a == b  ist ZahlEins == 1 ? %d\n", zahlEins == 1);

  // Auch komplexere Berechnungen == Ausdrücke sind möglich.
  zahlEins = 5*7 + 12 / 4 - 2;
  printf("Die Berechung ergibt %d\n", zahlEins);

  // Bei der Definition können wir auch direkt eine Variable initalisieren:
  int initalizedVar = 30;
  printf("Der wert der initalizedVar ist %d\n", initalizedVar);

  return 0;
}
