#include <stdio.h>

// Zeiger sind ein komplexeres und fehleranfälliges Sprachbestandteil.
// Oftmals kann man durch Zeiger aber auch die Leistung eines Programmes optimieren.

/**
Die Funktion addiert alle Zahlen im zahlen Array und gibt diese zurück
 */
int addiereVector(int anzahl, int * zahlen){ // wir hätten auch "int zahlen[]" schreiben können...
// Zur Erinnerung
// int zahl = 0; Damit wird die Variable Zahl als Integer deklarieriert, ihr wird ein Speicherbereich zugewisen, d.h. sie ist definiert und initalisiert auf 0.
// Über den Namen "zahl" weiß der Kompiler an welcher Speicherstelle die Variable sich befindet.
  int zahl = 0;

  for(int i=0; i < anzahl; i++){
    zahl += zahlen[i];
  }

  return zahl;
}

int main(int argumentCount, char ** argumente){
  // Zeiger zeigen auf Speicherbereiche / Variablen,
  // "Aliase" für die Variablen.
  int a = 5;

  int * b; // b ist ein Zeiger auf einen Integer
  b = & a; // wir lassen b auf a zeigen - indem wir in b die Adresse von a Speichern. Wir holen eine Referenz auf a.

  printf("a ist %d\n", a);

  // mit *b bekommen wir den Wert auf den B zeigt. Dies nennt man Dereferenzierung.

  *b = 4; // wir setzen den Wert auf den b Zeigt auf 4. In dem Fall wird also *b = a = 4 gesetzt.
  printf("Nach Veränderung von b ist a %d\n", a);


  // mit [] können wir auch arrays dereferenzieren. b[0] entspricht *b
  // wir lassen b auf einen Array mit 5 Zahlen zeigen.
  int array[] = { 1, 2, 3, 4, 5 };
  b = array;
  printf("*b = %d b[0] = %d b[3] = %d\n", *b, b[0], b[3]);

  // arrays und zeiger sind fast identisch (bis auf die Ablage im Speicher).

  // Zeiger können beliebig aufeinander zeigen:
  int ** c = & b; //c ist ein Zeiger auf einen Zeiger auf einen Integer.
  // die Kommandozeilenparameter werden als zweidimensionaler Array übergeben!

  // Über die Anzahl der Elemente müssen wir selbst Buch führen, ab zwei wirds in der Regel unübersichtlich!

  printf("Array addiert ist: %d \n", addiereVector(5, array));

  // wir können auch nur eine Teilmenge addieren vom Array, indem wir erst bei dem dritten Element anfangen zu addieren:
  printf("Array addiert von 3-5 Element ist: %d \n", addiereVector(3, array + 2));


  // Zeigerarithmetik ist komplex: array + 2 == & array[2] => Adresse des zweiten Elementes
  // C merkt sich die Größe des Datentypes und inkrementiert die Zeiger in Größenordnungen des Datentyps.

  printf("Adressen von array + 2 und & array[2] sind hexadezimal: %p und %p \n", array + 2, &array[2]);

  // die Adressen im Speicher können sich je nach Aufruf ändern. (Starte das Programm einfach mehrfach).

  // wir geben die Speicheradresse von a aus:
  printf("Speicheradresse von a ist: %p\n", & a);
}
