#include <stdio.h>

// Variablen verschiedener Datentypen können auch ineinander umgewandelt werden, sofern dies sinnvoll ist.

int main(){
  int a = 40000;

  double b = a; // hier wird implizit ein Integer zu einem double umgewandelt!

  b = 0.123456789;

  int c = b; // hier wird implizit ein double in ein integer umgewandelt.
  // die Genauigkeit leidet darunter, sofern der Wert sich nicht exakt umwandeln lässt

  float d = b;
  // auch hier leidet die Genauigkeit, früher war dies ein Fehler in der Programmierung
  // heute bekommt man eine Warnung nur noch wenn man mit -Wconversion kompiliert.

  printf("a=%d b=%.9f c=%d d=%.9f \n", a, b, c, d);

  // besser ist es explizit typen umzuwandeln, dafür einfach den Datentyp in Klammern angeben:
  float f = (float) b;

  // nützlich auch beim Ausdrucken:
  printf("b als Int umgewandelt ist %d\n", (int) b);

  // das ganze funktioniert auch bei Zeigern:
  // void * ist ein Zeiger auf irgendetwas (!), Vorsicht also.
  void * p = & a;

  // um darauf zuzugreifen müssen (sollten) wir erst wieder auf den Datentyp casten:
  printf("Wert von *p (zeigt auf a) als int ist: %d\n", *((int*) p));

  // Vorsicht bei Verwendung eines falschen Datentyps, da Weisen wir Speicher zu...
  printf("Wert von *p (zeigt auf a) als float macht keinen Sinn und ergibt: %f\n", *((float*) p));

  // wir geben uns einmal die Werte im Speicher für eine Zahl aus:
  int val = (1<<17) + (1<<16) + (1<<8) + 4 + 1;
  // 2^(17) + 2^(16) + 2^(8) + 4 + 1 = 131072 + 65536 + 256 + 4 + 1 = 196869 = 00000000 00000011 00000001 00000101

  printf("Im Speicher steht für Val %d der Wert: \n", val);

  for (int c = 0; c < sizeof(val); c++){
    // char hat die Größe 1.
    unsigned char * z = (unsigned char *) & val;

    // z ist auch ein Array
    printf("%p : %d  \n",  z + c, z[c]);
    printf("Jetzt als Int: %d\n", z[c] * 1<<(8*c));
  }

  printf("Niedrige Addresse + wenigst wichtigstes Byte => little Endian \n");
}
