#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

// wir machen die neuen Funktionen bekannt:
#include "18-modular-programmieren-lib.h"

static int fd;

void my_init(char const * filename){
  // eine Datei zum schreiben öffnen und die Zugriffsrechte darauf setzen
  // wir bekommen einen FileDescriptor zurück, ein "Objekt", welches die offene Datei beschreibt.
  fd = open(filename,  O_CREAT | O_TRUNC | O_WRONLY, S_IRUSR | S_IWUSR);
  // do error handling...
  if (fd < 0){
    // we should do error handling here.
  }
}

void my_ioWriter(int count, int * array){
    for(int i=0; i < count ; i++){
      char buff[256];
      
      snprintf(buff, sizeof(buff), "%d\n", array[i]); // das 256. Byte wird bereits durch snprintf auf 0 gesetzt

     // wir schreiben in die bereits geöffnete Datei (über den FileDescriptor fd) buff hinein
     // Normalerweise sollten wir den Rückgabewert von write überprüfen...
      write(fd, buff, strlen(buff));
    }
}

void my_finalize(){
  close(fd);
}
