#include <stdio.h>

/*
	In dieser Lektion wollen wir etwas genauer erläutern, wie Bibliotheken erstellt und genutzt werden.
	Was ist das wichtigste um Modular zu programmieren?
	Trennung von Schnittstelle und Implementation.
	Es wird versucht nach außen ein Stabiles Interface bereit zu stellen, während die Implementation sich 
	ändern kann und vor dem Nutzer verborgen ist.
*/

#include "18-modular-programmieren-lib.h"

#warning compile with:  gcc -Wall -o 18-modular-programmieren-lib 18-modular-programmieren-lib.c -std=c99 -lm -ggdb 18-modular-programmieren.c

// hier nutzen wir das zur Verfügung stehende Interface
int main(){
  my_init("/tmp/arrayFile");

  int vals[10] = {1, 2, 4, 8, 32, 1024, 24142, 14, 124, 124 };

  my_ioWriter(10, vals );

  my_finalize();

  printf("Fertig\n");

  return 0;
}


/*
Um eine Bibliothek zu erstellen ist das ganze etwas komplexer:

gcc -c -fPIC 18-modular-programmieren-lib.c -Wall  -std=c99
gcc -shared -Wl,-soname,libmy.so -o libmy.so  18-modular-programmieren-lib.o
gcc 18-modular-programmieren.c -o 18-modular-programmieren-shared -Wall -std=c99  -L . -lmy

Anzeigen welche Shared Objects genutzt werden mit
  ldd <DATEI>

Ausführen mit:
LD_LIBRARY_PATH=. ./18-modular-programmieren-shared

*/
