/*
  Für komplexere Datenstrukturen bietet sich die GLIB an,
  die GLIB ist das "Boost" von C++ für C.
  http://library.gnome.org/devel/glib/stable/

  Siehe auch:
  http://www.ibm.com/developerworks/linux/tutorials/l-glib/section5.html

  gcc  27-glib-hashtable.c -o 27-glib-hashtable  -Wall -std=c99 `pkg-config --libs --cflags glib-2.0`

  Es gibt auch viele I/O-Funktionen in der GLIB z.B. für das Einlesen einer ganzen Zeile ...
*/

#include <glib.h>
#include <stdlib.h>

int main(int argc, char** argv) {

 // hier erstellen wir eine HashTable, diese enthält Schlüssel-Wert Paare (Tupel), der Schlüssel
 // kann effizient gesucht werden in O(log(N)) Zeit.
 GHashTable* hash = g_hash_table_new(g_str_hash, g_str_equal);

 // fügen zwei Schlüssel-Wert Paare ein
 g_hash_table_insert(hash, "ComOpt", "Stellingen");
 g_hash_table_insert(hash, "WR", "DKRZ");

 printf("Es gibt %d Schlüssel\n", g_hash_table_size(hash));

 // Nachschlagen des Wertes für WR und Ausgabe:
 printf("Ort von WR: %s\n", g_hash_table_lookup(hash, "WR"));

 // hier entfernen wir den Tupel für WR
 g_hash_table_remove(hash, "WR");

 g_hash_table_destroy(hash);
 return 0;
}

