#include <stdio.h>

/**
 Jedes Programm kann Argumente über die Kommandozeile "bekommen".
 Die Anzahl der Argumente wird übergeben und eine "Liste" von Argumenten.
 Das erste Argument in der "Liste" ist immer der Programmname.
 */
int main(int argumentCount, char ** argumente){

  // wir iterieren über alle Argumente:
  for(int i=0; i < argumentCount ; i++){
    // %s ist das Format für Zeichenketten.
    // wir geben das i-te Element der Liste aus und die Nummer des Elementes,
    // Printf kann beliebig viele Werte ausgeben.
    printf("Das %d Argument ist %s \n",  i,  argumente[i]);
  }

  // wir prüfen ob Argumente übergeben wurden
  if( argumentCount <= 1 ){
    // es wurde nur der Programmname übergeben
    printf("Bitte geben Sie Argumente an\n");

    // wir geben einen Fehler zurück.
    return 1;
  }

  // wir konkatenieren die übergeben Strings vorwärts:
  for(int i=1; i < argumentCount ; i++){
    printf("%s", argumente[i]);
  }
  // Newline ausgeben:
  printf("\n");

  // ausgabe rückwärts:
  for(int i=argumentCount - 1 ; i > 0 ; i--){
    printf("%s", argumente[i]);
  }
  
  // Satzende ausgeben:
  printf("\n");

  // erfolgreicher Programmablauf
  return 0;
}
