#include <stdio.h>

// In diesem Beispiel wollen wir existierende Funktionen zur Verarbeitung von Zeichenketten nutzen.
// die Datei string.h enthält weitere Deklarationen zur Verarbeitung von Zeichenketten (strcmp)
#include <string.h>

// Funktionsdeklaration (oft Prototyp genannt), <Rückgabewert> <Name>(<Paramaterliste>)
// Der Compiler prüft bei Aufrufen ob die korrekten Typen übergeben wurden.
// Dafür muss die Deklaration an der Stelle bekannt sein! Deswegen werden die Header-Dateien eingebunden.

// void bedeutet kein Rückgabewert, bzw. Parameter.
void square(void);

// die Funktion "quadrat" nimmt eine Zahl als Parameter
void quadrat(int width);

// die Funktion "circle" gibt den Umfang zurück.
int  circle(int radius);


/** Funktionsdefinitionen == Implementierung der Funktion **/

void square(){
  printf("Funktion square wird aufgerufen\n");
}

void quadrat(int width){
  int umfang = width * 4;
  printf("Der Umfang des Quadrates mit der Seitenlänge %d ist: %d\n", width, umfang);
}

int circle(int radius){
  // wir geben den angenaherten wert für den umfang zurück:
  return 2 * 3 * radius;
}

/** Benutzt werden die Funktionen dann so: **/

int main(int argumentCount, char ** argumente){

   // für alle Eingabeparameter, ausser dem Programmnamen
   for(int i=1; i < argumentCount ; i++){

     // mit strcmp können wir zwei Zeichenketten vergleichen. Der Rückgabewert 0 bedeutet sie sind gleich.

     if ( strcmp( argumente[i], "square") == 0 ){
       // wir rufen die Funktion square auf, in den Klammern stehen die Parameter (hier leer);
       square();
       continue;
     }

     if ( strcmp( argumente[i], "quadrat") == 0 ){
       // wir wollen den Umfang des Quadrates der i-ten Stelle wissen.
       quadrat(i);
       continue;
     }

     if ( strcmp( argumente[i], "circle") == 0 ){
       int circleUmfang = circle(i);
       printf("Der Umfang des Kreises mit Radius %d ist ungefähr %d\n", i, circleUmfang);
       continue;
     }

     //ungültiger parameter:
     printf("Invalid parameter: %s\n", argumente[i]);

     // die Schleife läuft aber trotzdem weiter...
   }

   return 0;
}

