
// Zusätzliche Funktionalität wird in Bibliotheken bereitgestellt
// Um Programme zu kompilieren müssen einmal für Funktionen "Header-Dateien"
// bereitgestellt werden, welche die Funktionsprotypen enthalten, diese
// werden mit include eingebunden.
// Die Funktionen müssen noch innerhalb des Programms "definiert" sein, d.h.
// Code um diese aufzurufen muss vorhanden sein.

// Hierfür muss die Bibliothek noch hinzu gefügt (== gelinkt) werden.
// Die Standartbibliothek (GNU-C-Library) wird automatisch hinzu gelinkt.
// Details zur GNU-C-Library (GLIBC) siehe: http://www.gnu.org/software/libc/manual/html_node/index.html
// Die GLIBC implementiert die Spezifikationen: ISO C 99, POSIX.1c, POSIX.1j, POSIX.1d, Unix98, Single Unix Specification um portabel zu sein.

#include <stdio.h>
#include <stdlib.h>

// Die Mathe-Bibliothek muss bei gcc explizit hinzu gelinkt werden mit "-l m"
// -l <Bibliothek> teilt dem Compiler mit, er solle die Bibliothek auf referenzierten Symbolen "überprüfen". (Später mehr dazu):

/* Probiere einmal aus:
 gcc -Wall 7-standard-bibliothek.c -o 7-standard-bibliothek -std=c99
 /tmp/ccbKNYiw.o: In function `main':
 7-standard-bibliothek.c:(.text+0x46): undefined reference to `sin'

 gcc -Wall 7-standard-bibliothek.c -o 7-standard-bibliothek -std=c99 -lm

 Die Linux-Distributionen enthalten oftmals "development bzw. dev" Pakete um die Header Dateien bereit zu stellen.

 Für viele Funktionen bekommt man unter Linux mit dem Befehl "man <Befehl>" Hilfe über die Verwendung.
 Probiere doch aus:
 man atof
 man printf
*/

#include <math.h>

int main(int argumentCount, char ** argumente){
  for(int i=1; i < argumentCount ; i++){
    float value = atof(argumente[i]);
    printf("Der Sinus vom Radian %f ist %f\n", value, sin(value));
  }

  return 0;
}