#include <stdio.h>
#include <stdlib.h>

int main(int argumentCount, char ** argumente){

  // Wir können auch Vektoren (Arrays) von Werten definieren.
  // Die Tabelle enthält die Quadratzahlen.
  int lookupTable[] = {1,4,9,25,36,49};

  for(int i=1; i < argumentCount ; i++){
    int wert = atoi(argumente[i]);

    printf("Die Lookuptable für den Wert %d ist %d \n", wert, lookupTable[wert] );
  }

  // im Speicher liegen die Zahlen hintereinander und mit dem Operator [] greifen wir auf einen Wert an einer bestimmten Stelle in diesem Array zu.
  //VORSICHT in C beginnt die Zählung bei 0 => lookupTable[0] gibt den ersten Wert (hier 1) zurück!

  // wir können auch Werte in einem Array verändern:
  lookupTable[0] = 10;

  // somit können wir sehr leicht lookup tabellen selbst berechnen
  int lookupTableThree[100]; // die Dimension des Arrays (== Größe) ist 100, d.h. bietet Raum fuer 100 Elemente des Typs int

  // hier berechnen wir für die ersten 100 Zahlen (Zahl^3)
  for(int i=0; i < 100; i++){
    lookupTableThree[i] = i * i * i;
  }

  for(int i=1; i < argumentCount ; i++){
    int wert = atoi(argumente[i]);
    printf("Die Lookuptable für den Wert %d^3 ist %d \n", wert, lookupTableThree[wert] );
  }

  // Wir können auch Zeichenketten (Umgangsprachlich Strings) abspeichern.
  // '<Zeichen>' gibt den ASCII-Zahlen-Wert für das Zeichen zurück.
  char name[] = { 'N', 'a', 'm', 'e', 0 };   // das ist equivalent zu name[] = "Name";

  printf("Der String ist: %s\n", name);

  // in C enden alle Zeichenketten auf das Byte "0"
  char nameEinfach[] = "nameEinfacher";   // das ist equivalent zu name[] = "Name";
  printf("Einfacher gehts mit: %s\n", nameEinfach);
  
  return 0;
}
